#include SFCryptor.H
local loCryptor as SFCryptor of SFCryptor.vcx

* Create an instance of SFCryptor and set certain properties.

loCryptor = newobject('SFCryptor', 'SFCryptor.vcx')
loCryptor.nEncryptionMethod = ENCODER_LEVEL2	&& try other methods to see the difference
loCryptor.cPassword         = 'FoxRocks!'

* Encrypt a string.

lcStringToEncrypt = 'MyString'
lcEncryptedString = loCryptor.EncryptString(lcStringToEncrypt)
if not isnull(lcEncryptedString)
	messagebox(lcStringToEncrypt + ' encrypts using method ' + ;
		transform(loCryptor.nEncryptionMethod) + ' and password ' + ;
		loCryptor.cPassword + ' to ' + lcEncryptedString)

* Decrypt the same string.

	lcStringToEncrypt = loCryptor.DecryptString(lcEncryptedString)
	if not isnull(lcStringToEncrypt)
		messagebox('The encrypted string decrypts back to ' + ;
			lcStringToEncrypt)
	else
		messagebox(loCryptor.cErrorMessage)
	endif lnStatus = CRYPTOR_ERR_SUCCESS
else
	messagebox(loCryptor.cErrorMessage)
endif not isnull(lcEncryptedString)

* Let's check out the file encode and decode functions.

create table TEST (FIELD1 C(10), MEMO1 M)
index on FIELD1 tag FIELD1
insert into TEST values ('A', 'My memo')
use
lcFile = fullpath('TEST.DBF')
llOK   = loCryptor.Encrypt(lcFile)
if llOK
	messagebox('We should get an error when trying to USE the table ' + ;
		"because it's encrypted. Choose Ignore so we can continue.")
	use TEST
	llOK = loCryptor.Decrypt(lcFile)
	if llOK
		use TEST
		if used('TEST')
			messagebox('The table was successfully decrypted.')
			browse
			use
		endif used('TEST')
	else
		messagebox(loCryptor.cErrorMessage)
	endif llOK
else
	messagebox(loCryptor.cErrorMessage)
endif llOK

* Now let's see how we can decrypt the file in memory only so it stays
* encrypted on disk.

lcFile = forceext(lcFile, '*')
llOK   = loCryptor.Encrypt(lcFile)
if llOK
	llOK = loCryptor.Register(lcFile)
	use TEST
	if used('TEST')
		messagebox('The table was decrypted in memory so we can use it.')
		browse
		use
	endif used('TEST')
	llOK = loCryptor.Unregister(lcFile)
	if llOK
		messagebox('We should get an error when trying to USE the table ' + ;
			"because it's still encrypted. Choose Ignore so we can continue.")
		use TEST
	else
		messagebox(loCryptor.cErrorMessage)
	endif llOK
else
	messagebox(loCryptor.cErrorMessage)
endif llOK

* Clean up.

use
erase TEST.DBF
erase TEST.CDX
erase TEST.FPT
